% linprog_bsp.m
% Kap. 7.5.3
% Transportproblem als lineares Programm

% Angebote 
a1 = 4; a2 = 5; a3 = 6;

% Nachfragen
b1 = 1; b2 = 3; b3 = 2; b4 = 5;

% Transportkostenmatrix
c = [1 2 4 3; 5 1 2 6; 2 3 7 1];

% Vektor g der Zielfunktion
g = [c(1,:).'; c(2,:).'; c(3,:).'];

% Matrix der Gleichungsnebenbedingungen
Aeq = [1 0 0 0 1 0 0 0 1 0 0 0;
       0 1 0 0 0 1 0 0 0 1 0 0;
       0 0 1 0 0 0 1 0 0 0 1 0;
       0 0 0 1 0 0 0 1 0 0 0 1];
beq = [b1 b2 b3 b4].';     

% Matrix der Ungleichungsnebenbedingungen
A = [1 1 1 1 0 0 0 0 0 0 0 0;
     0 0 0 0 1 1 1 1 0 0 0 0;
     0 0 0 0 0 0 0 0 1 1 1 1;
     -1.*eye(12)];
b = [a1 a2 a3 zeros(1,12)].';

% Lsung des Transportproblems als lineares Programm
x = linprog(g,A,b,Aeq,beq)