% min_mnb_plot.m
% Kap. 7.5
% Minimierung mit Nebenbedingungen

% Erzeugen der Plots aus Kap. 7.5.1

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Funktion 7 mit Nebenbedingung plotten
% Nebenbedingung: (x1-0.5)^2+x2^2=1 (Kreis mit Radius 1 und MP=(0.5, 0))
% Parameterdarstellung: x1(t)=0.5+sin(t); x2(t)=cos(t) t=0..2*pi
%

% funktion7 in eigene figure plotten

clear Z
subplot(2,2,1)
xp = -1.5:0.1:1.5; yp = -1.5:0.1:1.5;
[X, Y] = meshgrid(xp, yp);
Z = 2.*X.^4 + Y.^4 -2.*X.^2 -2.*Y.^2 + 4.*sin(X.*Y);
surf(X,Y,Z)
view(-14,20)
axis([-1.5 1.5 -1.5 1.5 -5 10])
xlabel('x_1'); ylabel('x_2'); zlabel('f(x_1,x_2)'); title('Zielfunktion')

% Nebenbedingung Kreis in 3d Bild plotten

subplot(2,2,2); hold on
t = 0:0.1:2*pi+0.1;
x = 0.5+sin(t);
y = cos(t);
z = 2.*x.^4 + y.^4 -2.*x.^2 -2.*y.^2 + 4.*sin(x.*y);
plot3(x,y,z,'k') % Kreis auf funktion7 projeziert plotten
plot3(x,y,-5.*ones(1,length(x)),'k') % Kreis in der Ebene z=-5 plotten
grid on
axis([-0.5 1.5 -1.2 1.2 -5 7])
view(-14,20)
xlabel('x_1'); ylabel('x_2'); zlabel('f(x_1,x_2)'); title('Gleichungs NB')
hold off
% print -depsc f7mitnb.eps

%%%%%%%%%%%%%%%%% Ende Plot %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% lineare Gleichungsnebenbedingung
% x2-x1<=0
% -x2<=1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Bereich in der x1-x2-Ebene plotten
figure
subplot(2,2,1)
x1 = -2.5:0.1:1.5;
plot(x1,-1.*ones(1,length(x1)))   % 2. Nebenbedingung -x2<=1
hold on
plot(x1,x1)                       % 1. Nebenbedingung x2-x1<=0
grid on
axis([-2.5 1.5 -2.5 1.5])
xlabel('x_1'); ylabel('x_2'); title('Ungleichungs NB')
text(0.5,-0.3,'B','fontsize',[14])
% print -deps bereich.eps
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
